#ifndef QUARK_SHELL_H
#define QUARK_SHELL_H

#include <sys/types.h>
#include <kernel/Console.h>
#include <debug/Debug.h>

extern Console * activeConsole;
extern Debug * activeDebug;

class Shell
{
private:
	void resetBuffer();
	void executeCommand();
public:
	Shell();
	void execute();
};

#endif
