.globl DivideException, OverflowException, BreakpointException, NMIException, DebugException, BoundsException, InvalidOpcodeException, CPNotFoundException, DoubleFaultException, CPSegOverrunException, InvalidTSSException, SegNotPresentException, StackSegOverrunException, GeneralProtectionException, PageFaultException, CPErrorException, AlignmentCheckException,MachineCheckException,ReservedException

.extern KernelExceptionHandler

DivideException:
	pushl $-1
	pushl $0
	jmp GenericExceptionHandler

DebugException:
	pushl $-1
	pushl $1
	jmp GenericExceptionHandler

OverflowException:
	pushl $-1
	pushl $2
	jmp GenericExceptionHandler

BreakpointException:
	pushl $-1
	pushl $3
	jmp GenericExceptionHandler

NMIException:
	pushl $-1
	pushl $4
	jmp GenericExceptionHandler

BoundsException:
	pushl $-1
	pushl $5
	jmp GenericExceptionHandler

InvalidOpcodeException:
	pushl $-1
	pushl $6
	jmp GenericExceptionHandler

CPNotFoundException:
	pushl $-1
	pushl $7
	jmp GenericExceptionHandler

DoubleFaultException:
	pushl $8
	jmp GenericExceptionHandler

CPSegOverrunException:
	pushl $-1
	pushl $9
	jmp GenericExceptionHandler

InvalidTSSException:
	pushl $10
	jmp GenericExceptionHandler

SegNotPresentException:
	pushl $11
	jmp GenericExceptionHandler

StackSegOverrunException:
	pushl $12
	jmp GenericExceptionHandler

GeneralProtectionException:
	pushl $13
	jmp GenericExceptionHandler

PageFaultException:
	pushl $14
	jmp GenericExceptionHandler

ReservedException:
	pushl $-1
	push $15
	jmp GenericExceptionHandler

CPErrorException:
	pushl $-1
	pushl $16
	jmp GenericExceptionHandler

AlignmentCheckException:
	pushl $-1
	pushl $17
	jmp GenericExceptionHandler

MachineCheckException:
	pushl $-1
	pushl $18
	jmp GenericExceptionHandler

GenericExceptionHandler:
	pushl %ds
	pushl %ss
 	pushl %es
  	pushl %fs
 	pushl %gs
	pushl %esi
	pushl %edi
	pushl %ebp
	pushl %esp
	pushl %edx
	pushl %ecx
	pushl %ebx
	pushl %eax
	movl %cr0,%eax
	pushl %eax
	movl %cr2,%eax
	pushl %eax
	movl %cr3,%eax
	pushl %eax
	call	_Z22KernelExceptionHandler23exception_registers_tag
	addl $72, %esp
hang:	jmp hang
