#include <stdio.h>
#include <math.h>

int main(int argc , char * argv[])
{
	FILE * f;
	unsigned long size = 0x00;

	if(argc !=2)
	{
		printf("Usage : kernelsize <FILE>\n");
		return 1;
	}

	f = fopen(argv[1],"r");
	if(!f)
	{
		printf("Unable to open the file %s",argv[1]);
		return 2;
	}
	while(!feof(f))
	{
		(void)fgetc(f);
		size++;
	}
	fclose(f);

	printf("Kernel Size \t= 0x%lX\nSectors Needed \t= 0x%X\n",
		size,(unsigned)ceil((double)size/512));

	return 0;
}

