#ifndef QUARK_BIOS_H
#define QUARK_BIOS_H

#include <sys/types.h>

#define BIOS_OUT_PORT	0x70
#define BIOS_IN_PORT	0x71

#define STATUS_A	0x0A
#define STATUS_B	0x0B
#define STATUS_C	0x0C
#define STATUS_D	0x0D

#define SECOND_MASK 	0x00
#define MINUTE_MASK 	0x02
#define HOUR_MASK	0x04
#define DAY_MASK	0x06
#define DATE_MASK	0x07
#define MONTH_MASK	0x08
#define YEAR_MASK	0x09

// BIOS Interface Routines
int isBusyBIOS();
int bcd2bin(byte);
int readBIOS( byte );

#endif
