#ifndef QUARK_DMA_H
#define QUARK_DMA_H

#include <sys/types.h>

// The 8237 DMA Controller Interface
typedef struct dma_channel_tag
{
	uchar page;
	uchar offset;
	uchar length;
} DMAChannelInfo;

/*
 *	Abstracts the 8237a Interface.
 *		The Floppy Disk Driver , Hard Disk Driver , N/W Drivers , and
 *	other high speed drivers utilize DMA Channels for data transfer.
 */
class DMAController
{
private:
public:
	DMAController();
	void initialize();
	void transfer (byte,ulong,uint,byte);
};

#endif
