#ifndef QUARK_KERNEL_H
#define QUARK_KERNEL_H

// Interrupt Disable / Enable routines for Mutual Exclusion
#define disableInterrupts() __asm__ ("cli")
#define enableInterrupts()  __asm__ ("sti")
#define saveFlags(w) __asm__ __volatile__("pushfl; popl %0":"=r"(w)::"memory")
#define restoreFlags(w) __asm__ __volatile__("pushl %0; popfl"::"r"(w):"memory")

#endif
