#ifndef QUARK_PIT_H
#define QUARK_PIT_H

#define PIT_MODE 	0x43
#define PIT_COUNTER0 	0x40
#define PIT_FREQUENCY	1193182

// The 8254 Programmable Interval Timer Interface
#include <sys/types.h>
#include <asm/io.h>
#include <kernel/IDT.h>
#include <kernel/PIC.h>

/*
 *	The 8254 Programmable Interval Timer Interface
 */
class PIT
{
private:
public:
	PIT();
	
	void initialize(PIC *, IDT *);
};

void initTimeArea();
void schedule();
int Handler_TimerIRQ();

#endif
