#ifndef QUARK_STRING_H
#define QUARK_STRING_H

#include <sys/types.h>

size_t strlen(const char * s);
size_t strnlen(const char * s , size_t maxlen);
char * strcpy( char * to , const char * from);
char * strncpy( char * to , const char * from , size_t count );
char * strcat ( char * s , const char * t);
char * strncat ( char * dest , char * src , register size_t n );
char * strchr(const char * s , int c );
char * strstr( const char * haystack , const char * needle );
int strcmp ( const char * s1 , const char * s2 );
int strncmp ( const char * s1 , const char * s2 , size_t n);
int strcasecmp ( const char * s1 , const char * s2);
int strncasecmp ( const char * s1 , const char * s2 , register size_t n);

extern void * memcpy ( void * dest , const void * src , size_t size);
void * memset ( void * buf , int c , size_t len );
void * memchr(const void * s , register uchar c,register size_t n);
int memcmp ( const void * m1 , const void * m2 , size_t len);

#endif
