#include <kernel/Bios.h>
#include <asm/io.h>

int isBusyBIOS()
{
	outb ( BIOS_OUT_PORT , 0x80 | STATUS_A );
	return ( inb(BIOS_IN_PORT) & 0x80 );
}

int bcd2bin ( byte bcd )
{
	return  ( 10 * ( bcd >> 0x04 ) + ( bcd & 0x0F ) );
}

int readBIOS( byte address )
{
	while(isBusyBIOS()) ;
	outb ( BIOS_OUT_PORT , 0x80|address );
	return bcd2bin ( inb(BIOS_IN_PORT) );
}
