#include <kernel/Speaker.h>
#include <asm/io.h>

void Speaker::sound(uint frequency)
{
	byte status;
	frequency = 1193182 / frequency;
	
	outb( SPEAKER_CTRL , 0xB6 );
	outb( SPEAKER_DATA , (byte) frequency );
	outb( SPEAKER_DATA , (byte) (frequency >> 0x08) );

	status = inb(0x61);
	if(status != (status|0x03))
		outb( 0x61 , status|3 ) ;
}

void Speaker::nosound()
{
	outb( 0x61 , inb(0x61) & 0xFC );
}
